uniform float Time;
uniform sampler3D Noise1;
uniform samplerCube SkyBox;
//uniform samplerShade Shade;

varying vec3 vNormal;
varying vec3 vLight;
varying vec3 vHalfVec;
varying vec4 vDiffuse, vAmbient;
varying vec3 vPos;
varying float vTerrain_z;

void main(void)
{
  vec3 n,halfV;
  float NdotL,NdotHV;
  








vec3 vEye = (gl_NormalMatrix*vNormal).xyz;
float fBumpScale = 0.5f;
vec3 pos = vPos;
/*
	float fDepth = texture3D(Noise1, vPos.xyz).w;
	vec2 vHalfOffset = normalize(vEye).xy * (fDepth) * fBumpScale;

	fDepth = (fDepth + texture3D(Noise1, vPos + vec3(vHalfOffset,0)).x) * 0.5;
	vHalfOffset = normalize(vEye).xy * (fDepth) * fBumpScale;

	fDepth = (fDepth + texture3D(Noise1, vPos + vec3(vHalfOffset,0)).x) * 0.5;
	vHalfOffset = normalize(vEye).xy * (fDepth) * fBumpScale;
	
	pos=vPos + vec3(vHalfOffset,0);
*/


  // uprava normaly pro bumpmaping
  float tp=vPos.z/10.0+vTerrain_z/10.0;
//  vec4 noisy1 = texture3D(Noise1,vec3(pos.x*1.0,pos.y*1.0,Time*2.0+tp)).rgba*2.0-1.0;
  vec4 noisy1 = texture3D(Noise1,vec3(vPos.x*0.3,vPos.y*0.3,Time*2.0+tp)).rgba*2.0-1.0;
  vec4 noisy2 = texture3D(Noise1,vec3(vPos.x*0.07,vPos.y*0.07,Time+(tp)*1.3)).rgba*2.0-1.0;

//  vec3 noisy=noisy1.rgb;
  vec3 noisy=mix(normalize(noisy1.rgb),normalize(noisy2.rgb),0.5);
//  float noise_mul=vWater_w*1.0;
  float noise_mul=0.3;
  n = normalize(gl_NormalMatrix*(vNormal+noisy.xyz*noise_mul));
  // nalezeni texelu z cube mapy
  vec4 cube_color = textureCube(SkyBox, normalize(gl_TexCoord[0].xyz+noisy.xyz).xyz).rgba;

  // vypocet vysledne barvy
  vec4 color = vAmbient;          // zakladni slozka vsudypritomneho svetla
  NdotL = max(dot(n,vLight),0.0);

  // pokud je to osvetleno
  if (NdotL > 0.0) {
    color += vDiffuse * NdotL;    // normalni osvetleni
    color = color*color*cube_color*max(cube_color.r*0.85 + cube_color.b*0.5,1.0);       // kvuli prebijeni textury svetlem
    
    halfV = normalize(vHalfVec);  // zbytek pridava odlesky
    NdotHV = max(dot(n,halfV),0.0);
    NdotHV=pow(NdotHV,10.0);
    if(NdotHV<0.99) NdotHV=0.0;
    color += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess);
  }
  else
    color=color*color*cube_color;       // textura se uplatni i v zastinene oblasti

  // zapis vysledku
  color.a=min((color.r*2.0+color.g*2.0+color.b+0.3)/5.0,1.0); // XXX
  gl_FragColor=color;
//  noisy1.w+=1.0;
//  noisy1.w/=2.0;
//  gl_FragColor=vec4(noisy1.w,noisy1.w,noisy1.w,1.0);
}
